<?php
  /**
   * @version $Id: groupjive.php
   * @package Joomla!
   * @subpackage GroupJive
   * @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
   * @Joomla! is Free Software
   * @author Joshua Holmes
   * @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
   */

// defines
defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

global $mainframe, $Itemid;

// include CB framework
// check what files needs to be included
if ( defined( 'JPATH_ADMINISTRATOR' ) ) {
	$foundation	=	JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php';
	$pluginclass = JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.class.php';
	$comprofilerclass = JPATH_ADMINISTRATOR . '/components/com_comprofiler/comprofiler.class.php';
} else {
	$foundation	=	$mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/plugin.foundation.php';
	$pluginclass = $mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/plugin.class.php';
	$comprofilerclass = $mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/comprofiler.class.php';
}

// include the CB framework
require_once( $foundation );
// import CBs database library
cbimport( 'cb.database' );

require_once( $pluginclass );
require_once( $comprofilerclass );


global $_CB_framework;

// some constants
if (!defined('GJBASEPATH')){define ( 'GJBASEPATH', 'components/com_groupjive');}
if (!defined('GJ_REFERER')){define ( 'GJ_REFERER', cbGetParam($_SERVER, 'HTTP_REFERER', ''));}
if (!defined('JPATH')) define ('JPATH', $_CB_framework->getCfg('absolute_path'));

global $ueConfig, $gjConfig;

// include CB / CBE config 
if (file_exists(JPATH.'/administrator/components/com_comprofiler/ue_config.php')) {
	include_once(JPATH.'/administrator/components/com_comprofiler/ue_config.php');
} elseif (file_exists(JPATH.'/administrator/components/com_comprofiler/enhanced_admin/enhanced_config.php')) {
	include_once(JPATH.'/administrator/components/com_comprofiler/enhanced_admin/enhanced_config.php');
} else {
	die( 'Community Builder or Community Builder Enhanced is not installed. One of these components is required for GroupJive to function!' );
}

require_once( GJBASEPATH . '/helpers.php' );

require_once("administrator/components/com_comprofiler/imgToolbox.class.php");

require_once( JPATH.'/administrator/components/com_groupjive/groupjive.class.php');

require_once(JPATH.'/administrator/components/com_groupjive/gj_config.php');

require_once(JPATH.'/components/com_groupjive/gj/core/pms.php');

require_once( GJBASEPATH . '/groupjive_func.inc' );

$_PLUGINS->loadPluginGroup('user');
// init template object
global $_GJ_TEMPLATES;
$_GJ_TEMPLATES = new groupjive_template();

// controller function
// get the parameters from the URL
$gj_action 	= cbGetParam($_REQUEST, 'action', 'gj.core.categories.showoverview');
$task 		= cbGetParam($_REQUEST, 'task', '');

// workaround
// change task to action - J1.5 menu issue, can't add dots to stats XML
switch ($task) {
	case 'showcategory':
		$gj_action = 'gj.core.categories.showcategory';
		break;
	case 'showgroup':
		$gj_action = 'gj.core.groups.showgroup';
		break;
}

list($gj_type, $gj_name, $gj_pack, $gj_task) = split('\.', $gj_action);

include_once(GJBASEPATH.'/'.$gj_type.'/'.$gj_name.'/'.$gj_pack.'.php');

$controller = $gj_pack.'_controller';

$controller = new $controller($option, $gj_task, $_POST, $Itemid);
$controller->run();

$_GJ_TEMPLATES->processTemplate();


?>
<p align="center"><small>Groupjive Copyright &copy; 2006-2008 by <a href="http://www.groupjive.org" target="_blank">http://www.groupjive.org</a>.<br/>This is free software, and you may redistribute it under the <a href="http://www.gnu.org/licenses/old-licenses/gpl-2.0.html" target="_blank">GPL 2.0</a>.<br/> Groupjive comes with absolutely no warranty; for details, see the <a href="http://www.gnu.org/licenses/old-licenses/gpl-2.0.html" target="_blank">license</a>.</small></p>
