<?php
/**
* @version $Id: helpers.php
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/

global $_CB_framework;

$absolute_path = $_CB_framework->getCfg('absolute_path');

// php 4 compat files from PEAR
include_once($absolute_path.'/components/com_groupjive/compat/array_combine.php');

function escapeString ( $string ) {
	global $_CB_database;
	
	// doesnt work on my local system - needs some checks
	if (!get_magic_quotes_gpc()) {
		$string = $_CB_database->getEscaped( $string );
	}
	return $string;
}

// for J1.5 compatibility
function setTemplateVars( &$tmpl, $pagenav, $name = 'admin-list-footer' ) {
		$tmpl->addVar( $name, 'PAGE_LINKS', $pagenav->getPagesLinks() );
		$tmpl->addVar( $name, 'PAGE_LIST_OPTIONS', $pagenav->getLimitBox() );
		$tmpl->addVar( $name, 'PAGE_COUNTER', $pagenav->getPagesCounter() );
	}


/**
 * Legacy function, use {@link JUtility::sendMail()} instead
 *
 * @deprecated	As of version 1.5
 */
function gjMail($from, $fromname, $recipient, $subject, $body, $mode=0, $cc=NULL, $bcc=NULL, $attachment=NULL, $replyto=NULL, $replytoname=NULL ) {
	if (function_exists('mosMail')) {
		return mosMail($from, $fromname, $recipient, $subject, $body, $mode, $cc, $bcc, $attachment, $replyto, $replytoname );
	} else {
		return JUTility::sendMail($from, $fromname, $recipient, $subject, $body, $mode, $cc, $bcc, $attachment, $replyto, $replytoname );
	}
}
//	notify($group_id, $pms, '', '',"invite", $row, $ctime);
function notify($exgroup, $pms, $message, $newmember, $action = "notify", $userdata="", $ctime="") {
	global $_CB_database, $_CB_framework, $gjConfig;

	// needs some work
	// use PM class
	$gj_message = new gj_message();
	$gj_message->setPms( $pms );

	$gj_message->loadGroup($exgroup);

	switch ($action) {
		case 'notify':
		case 'notifyall':
			if( $gjConfig['notify'] ) {
				$action = 'notifyall';
			}
			$subject = GJ_ACTIVITY;
			$gj_message->loadReceiver($gj_message->_group->user_id);
			$gj_message->loadSender($_CB_framework->myId());
			break;
		default:
			$subject = GJ_INVITED;
			$gj_message->setInviteCode($ctime);
			$gj_message->loadReceiver($newmember);
			$gj_message->loadSender($_CB_framework->myId());
			break;
	}

	$gj_message->setMessage($message);

	$gj_message->setSubject($subject);
	$gj_message->setType($action);
	$gj_message->setRealnames( $gjConfig['real_names'] );

	$gj_message->send();
	if ($gj_message->getErrorNum()) {
		$error = $gj_message->getErrorMsg();
		echo $error;exit;
	}
	// end PM class
}
?>
