<?php
/**
* @version $Id: install.groupjive.php
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/

function com_install() {
global $_CB_database, $_CB_framework;

// include CB framework
global $mainframe;

if ( defined( 'JPATH_ADMINISTRATOR' ) ) {
	$foundation	=	JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php';
	if (!file_exists($foundation)) {
		$foundation	=	JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php';
	}
} else {
	$foundation	=	$mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/plugin.foundation.php';
	if (!file_exists($foundation)) {
		$foundation	=	$mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/plugin.foundation.php';
	}
}
include_once( $foundation );

cbimport( 'cb.database' );
?>

<div style="text-align:left;width:60%;">
  <div style="background-color:#fbfbfb;border:1px solid #EFEFEF;margin-bottom:5px;padding-right: 5px;">
    <h3>GroupJive Information</h3>
	<p><em><strong>GroupJive</strong></em> is a social networking component that creates Groups for the Joomla CMS! GroupJive requires the presence of Community Builder or Community Builder Enhanced user management components in your Joomla! installation.</p>
	<p><em><strong>GroupJive</strong></em> provides all registered Joomla! users the ability to create groups, join together with other users and generate content that is unique to their Group(s). GroupJive supports a group bulletin with WYSIWYG options, compatibility with almost all Joomla! PMS systems, a Plugin for Community Builder, a series of Modules that enhance the GroupJive user experience and integration with other Joomla! components including EventList, FireBoard, JomComment and more...</p>
	<p>Groups are based on three privilege levels which determine a users ability to access and join groups:</p>
	<ul>
	  <li><strong>Open to all</strong> - <em>(open to all registered users)</em></li>
	  <li><strong>Approval to join</strong> - <em>(requires Moderator to approve membership)</em></li>
	  <li><strong>Invite to join</strong> - <em>(membership is by invitation only)</em></li>
	</ul>
	<p><em><strong>REQUIREMENT:</strong></em> GroupJive requires the presence of Community Builder or Community
Builder Enhanced user management components. To use GroupJive, Community Builder
-OR- Community Builder Enhanced must be installed!</p>
	<p>Please review the <a href="components/com_groupjive/readme.txt" target="_blank"><big>readme.txt</big></a> in your installation package. It contains detailed information on GroupJive setup as well as integration instructions for components we support. Visit us at <a href="http://groupjive.org" target="_blank">http://www.groupjive.org</a> for more information. <strong>Thank you!</strong></p>
  </div>
  
  <div style="background-color:#fbfbfb;border:1px solid #EFEFEF;margin-bottom:5px;padding-right: 5px;">
    <h3>Installation Process</h3>
	<table><tr><th>Current step</th><th>Message</th></tr>
		<?php
/*		checkField('#__gj_options', 'bul_creator', "ENUM( '0', '1' ) NOT NULL DEFAULT '0'");					
		checkField('#__gj_options', 'real_names', "ENUM( '0', '1' ) NOT NULL DEFAULT '0'");					
		checkField('#__gj_options', 'nonreg', "ENUM( '0', '1' ) NOT NULL DEFAULT '0'");
		checkField('#__gj_options', 'bulletin', "ENUM( '0', '1' ) NOT NULL DEFAULT '1'");
		checkField('#__gj_options', 'jomcomment', "ENUM( '0', '1' ) NOT NULL DEFAULT '0'");
		checkField('#__gj_options', 'wysiwyg', "ENUM( '0', '1' ) NOT NULL DEFAULT '0'");
		checkField('#__gj_options', 'wysiwyg_width', "int(5) NOT NULL default '400'");
		checkField('#__gj_options', 'wysiwyg_height', "int(5) NOT NULL default '200'");
		checkField('#__gj_options', 'wysiwyg_rows', "int(5) NOT NULL default '80'");
		checkField('#__gj_options', 'wysiwyg_cols', "int(5) NOT NULL default '15'");
		checkField('#__gj_options', 'ajax_active', "enum('0','1') NOT NULL default '0'");
		checkField('#__gj_options', 'ajax_access', "tinyint(3) NOT NULL DEFAULT '0'");
		checkField('#__gj_options', 'ajax_message', "varchar(25) NOT NULL default 'load data'");
		checkField('#__gj_options', 'template', "varchar(25) NOT NULL default 'default'");
		checkField('#__gj_options', 'hideprivate', "ENUM( '0', '1' ) NOT NULL DEFAULT '0'");
		checkField('#__gj_options', 'jb_count', "int(5) NOT NULL default '5'");
		checkField('#__gj_options', 'el_count', "int(5) NOT NULL default '5'");
		checkField('#__gj_options', 'force_invite', "ENUM( '0', '1' ) NOT NULL DEFAULT '0'");
*/
		checkField('#__gj_grcategory', 'cat_image', "varchar(255) default NULL");
		checkField('#__gj_grcategory', 'access', "tinyint(3) NOT NULL DEFAULT '0'");
		checkField('#__gj_grcategory', 'ordering', "tinyint(4) default NULL");
		checkField('#__gj_grcategory', 'descr', "text NOT NULL default ''");
		checkField('#__gj_groups', 'params', "text NOT NULL default ''");

		/**
		 * check if value 'jim' exists in field pms in table gj_options
		 */
/*		showAction('check if value `jim` exists for `pms`');
		if (!checkIfValueExists('#__gj_options', 'pms', 'jim', 1)){
			showResult('value `jim` does not exist', true);
			showAction('try to add value `jim` to field `pms`');
			$sql = "ALTER TABLE `#__gj_options` MODIFY `pms` "
				. "ENUM('email','uddeim','mypms','pmsenh','jim','missus','clexus') "
				. "NOT NULL DEFAULT 'email'";
			$_CB_database->setQuery($sql);
	
			if(!$result=$_CB_database->query()) {
				showResult ('Error while alter table #__gj_options', false);
				echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
				return;
			}
			showResult ('added value `jim` to field `pms` in table #__gj_options', true);
		} else {
			showResult('value `jim` already exist', true);
		}
*/
		/**
		 * check if value 'missus' exists in field pms in table gj_options
		 */
/*		showAction('check if value `missus` exists for `pms`');
		if (!checkIfValueExists('#__gj_options', 'pms', 'missus', 1)){
			showResult('value `missus` does not exist', true);
			showAction('try to add value `missus` to field `pms`');
			$sql = "ALTER TABLE `#__gj_options` MODIFY `pms` "
				. "ENUM('email','uddeim','mypms','pmsenh','jim','missus','clexus') "
				. "NOT NULL DEFAULT 'email'";
			$_CB_database->setQuery($sql);
	
			if(!$result=$_CB_database->query()) {
				showResult ('Error while alter table #__gj_options', false);
				echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
				return;
			}
			showResult ('added value `missus` to field `pms` in table #__gj_options', true);
		} else {
			showResult('value `missus` already exist', true);
		}
*/

		/**
		 * check if value 'clexus' exists in field pms in table gj_options
		 */
/*		showAction('check if value `clexus` exists for `pms`');
		if (!checkIfValueExists('#__gj_options', 'pms', 'clexus', 1)){
			showResult('value `clexus` does not exist', true);
			showAction('try to add value `clexus` to field `pms`');
			$sql = "ALTER TABLE `#__gj_options` MODIFY `pms` "
				. "ENUM('email','uddeim','mypms','pmsenh','jim','missus','clexus') "
				. "NOT NULL DEFAULT 'email'";
			$_CB_database->setQuery($sql);
	
			if(!$result=$_CB_database->query()) {
				showResult ('Error while alter table #__gj_options', false);
				echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
				return;
			}
			showResult ('added value `clexus` to field `pms` in table #__gj_options', true);
		} else {
			showResult('value `clexus` already exist', true);
		}
*/
		/**
		 * check if gj_options is filled;
		 */
		showAction ('check if default settings exists');
		$sql = 'SELECT settings FROM #__gj_settingsstore WHERE id = 1'; 
		$_CB_database->setQuery($sql);

		if(!$result=$_CB_database->query()) {
			showResult ('Error while selecting the default values into table #__gj_settingsstore', false);
			echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
			return;
		}

		$value_exists = $_CB_database->getNumRows() > 0;

		if (!$value_exists) {
			$mytemplate = 'default';

			$txt = '<?php
$gjConfig[\'send_admin_emails\']=\'0\';
$gjConfig[\'admin_email\']=\'Webmaster@MyDomain.com\';
$gjConfig[\'real_names\']=\'0\';
$gjConfig[\'nophoto\']=\'components/com_comprofiler/images/english/tnnophoto.jpg\';
$gjConfig[\'pms\']=\'email\';
$gjConfig[\'onpage\']=\'5\';
$gjConfig[\'onpage_members\']=\'5\';
$gjConfig[\'template\']=\'default\';
$gjConfig[\'date_form\']=\'%d.%m.%Y\';
$gjConfig[\'create_groups\']=\'1\';
$gjConfig[\'delete_groups\']=\'1\';
$gjConfig[\'approval\']=\'0\';
$gjConfig[\'nonreg\']=\'0\';
$gjConfig[\'notifyjoin\']=\'0\';
$gjConfig[\'notify\']=\'0\';
$gjConfig[\'hideprivate\']=\'0\';
$gjConfig[\'force_invite\']=\'0\';
$gjConfig[\'version\']=\'0\';
$gjConfig[\'logosize\']=\'2000\';
$gjConfig[\'logoheight\']=\'500\';
$gjConfig[\'logowidth\']=\'500\';
$gjConfig[\'thumbheight\']=\'80\';
$gjConfig[\'thumbwidth\']=\'80\';
$gjConfig[\'bulletin\']=\'1\';
$gjConfig[\'bul_creator\']=\'0\';
$gjConfig[\'blogm\']=\'5\';
$gjConfig[\'wysiwyg\']=\'1\';
$gjConfig[\'wysiwyg_width\']=\'600\';
$gjConfig[\'wysiwyg_height\']=\'400\';
$gjConfig[\'wysiwyg_rows\']=\'5\';
$gjConfig[\'wysiwyg_cols\']=\'40\';
$gjConfig[\'ajax_active\']=\'0\';
$gjConfig[\'ajax_message\']=\'Load Data\';
$gjConfig[\'ajax_access\']=\'0\';
?'.'>';

			$sql = 'INSERT INTO `#__gj_settingsstore` (id, settings) VALUES (1, "'.$txt.'");';

			$_CB_database->setQuery($sql);

			if(!$result=$_CB_database->query()) {
				showResult ( 'Error while inserting the default values into table #__gj_settingsstore', false);
				echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
				return;
			}
			showResult('added default values into table #__gj_settingsstore', true);

		} else {
			showResult('Default Values found', true);
		}

		$sql = 'SELECT settings FROM #__gj_settingsstore WHERE id = 1'; 
		$_CB_database->setQuery($sql);
		$txt = $_CB_database->loadResult();

		cbimport( 'cb.adminfilesystem' );
		$adminFS			=&	cbAdminFileSystem::getInstance();

		$absolutepath		= $_CB_framework->getCfg( 'absolute_path' );
		$configfile			= $absolutepath.'/administrator/components/com_groupjive/gj_config.php';

		$result			=	$adminFS->file_put_contents( $configfile, $txt );
		if ( $result ) {

			// store settings into the database 
			$sql = 'UPDATE #__gj_settingsstore SET settings = "'.$_CB_database->getEscaped($txt).'" WHERE id = 1';
			$_CB_database->setQuery($sql);
			$_CB_database->query();

			if ( _gjAdmin_chmod( $configfile ) ) {
				$msg	=	"Configuration file saved";
			}
			else {
				$msg	=	'Failed to change the permissions of the config file '.$configfile;
			}
		}
		else {
			$msg		=	'Failed to create and write config file in '.$configfile;
		}

		/**
		 * check if gj_users needs an update 
		 * enum(0,1) to enum('active','inactive',...)
		 */
		showAction('check if usertable still uses new enum set');
		if (!checkIfValueExists('#__gj_users', 'status', 'active', 1)){
			showResult('table uses old values', true);
			showAction('try to alter table to use new values');

			// rename old field
			
			// add new field
			// move values from old field to new field
			// remove old field

			// 1. create a new table with the new structure
			$sql = "ALTER TABLE `#__gj_users`"
				. "\nADD `status_tmp` enum('active','inactive','invited','need approval','undefined') NOT NULL default 'undefined'";
			$_CB_database->setQuery($sql);
	
			if(!$result=$_CB_database->query()) {
				showResult ('Error while alter table #__gj_users - add field status_tmp', false);
				echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
				return;
			}
			// 2. move all the data from the old table to the new one
			// (change status from 0/1 to the specific value)
			$sql = "UPDATE #__gj_users"
				. "\nSET status_tmp ="
				. "\nCASE `status`"
				. "\nWHEN '0' THEN 'active'"
				. "\nWHEN '1' THEN 'inactive'"
				. "\nELSE 'inactive'"
				. "\nEND;";
			$_CB_database->setQuery($sql);
	
			if(!$result=$_CB_database->query()) {
				showResult ('Error while updating data in table #__gj_users', false);
				echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
				return;
			}
			
			// 3. delete the old table
			$sql = "ALTER TABLE `#__gj_users`"
				. "\nDROP `status`;";
			$_CB_database->setQuery($sql);
	
			if(!$result=$_CB_database->query()) {
				showResult ('Error while alter table #__gj_users - dropping old field status', false);
				echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
				return;
			}
			// 4. rename the new table 
			$sql = "ALTER TABLE `#__gj_users`"
				. "\nCHANGE `status_tmp` `status`"
				. "\nENUM( 'active', 'inactive', 'invited',"
				. "\n'need approval', 'undefined' )"
				. "\nNOT NULL DEFAULT 'undefined';";
			$_CB_database->setQuery($sql);
	
			if(!$result=$_CB_database->query()) {
				showResult ('Error while alter table #__gj_users rename status_tmp to status', false);
				echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
				return;
			}

			showResult ('successful altere table #__gj_users', true);
		} else {
			showResult('table still uses new enum set', true);
		}


		// check user fields
		$sql = "SELECT a.id"
			."\nFROM `#__gj_users` a"
			."\nINNER JOIN #__gj_users b ON a.id_user = b.id_user"
			."\nAND a.id_group = b.id_group"
			."\nWHERE a.id > b.id";
		$_CB_database->setQuery($sql);
		$result = implode(',', $_CB_database->loadResultArray());

		if ($result){
			$sql = "DELETE FROM #__gj_users WHERE id IN ($result)";
			$_CB_database->setQuery($sql);
			$_CB_database->query();
		}

		/**
		 * check if Index exists
		 */
		showAction ('Check if "unique_key" exists');
		if (indexExists('unique_key', '_gj_users')) {
			showResult ('Index "unique_key" exists', true);
		} else {
			showResult ('TODO check this --- Index "unique_key" not found', false);
			showAction ('Try to create index "unique_key"');
			$sql = "ALTER TABLE `#__gj_users` ADD UNIQUE `unique_key` ( `id_user` , `id_group` )";
			$_CB_database->setQuery($sql);

			if(!$result=$_CB_database->query()) {
				showResult ('TODO check this --- Error while alter table #__gj_users', false);
			} else {
				showResult ('added index "unique_key" to table #__gj_users', true);
			}
		}
		
		/**
		 * check if CB is installed
		 */
		showAction ('check if Community Builder Component is installed'); 
		$sql = "SELECT * FROM #__components WHERE name = 'Community Builder'";
		$_CB_database->setQuery($sql);
		$count = count($_CB_database->loadResult());
		if ($count > 0) {
			showResult ('Community Builder is installed', true);
		} else {
			showResult ('TODO check this --- Please install the Community Builder component, GroupJive will not function without it', false);
		}

		handleImages();?>
	</table>
	<p style="font-size:16px; color:#FF0099">Installation done!</p>
	<p style="color: #FF9900"><em>If no error occurs, Groupjive should be installed correctly.</em></p>
  </div>
  <div style="background-color:#fbfbfb;border:1px solid #EFEFEF;margin-bottom:5px;padding-right: 5px;">
    <h3>Support</h3>
	<p>For information and support please visit</p>
	<big><a href="http://www.groupjive.org" target="_blank">www.groupjive.org</a></big>
	<p>If you have problems with Groupjive, the support forums at GroupJive are the best place to find help, knowledge articles and experienced users with the community.</p>
	<p>You can help improve GroupJive by submitting your bug reports and feature requests to our joomlacode.org development site at:</p>
	<big><a href="http://joomlacode.org/gf/project/groupjive" target="_blank">ProjectGroupJive</a></big>
	<p>Please <a href="http://www.groupjive.org/index.php?option=com_comprofiler&task=registers" target="_blank">register</a> to stay informed.</p>
  </div>
  <div style="background-color:#fbfbfb;border:1px solid #EFEFEF;margin-bottom:5px;padding-right: 5px;">
    <?php showLicense(); ?>
  </div>
  <div style="background-color:#fbfbfb;border:1px solid #EFEFEF;margin-bottom:5px;padding-right: 5px;">
    <h2 style="color:#009900"><em>Thank you for using Groupjive.</em></h2>
  </div>
  </div>
  <?php
}

function checkIfTableExists($tablename) {
	global $_CB_database;

	$sql = "SHOW TABLE STATUS LIKE '$tablename'";
	$_CB_database->setQuery($sql);

	if(!$result=$_CB_database->query()) {
		echo '<p>'.$_CB_database->stderr().'</p>'; // this is not w3c valid
		return;
	}

	$table_exists = $_CB_database-> getNumRows() == 1;

	return $table_exists;
}

function getTableFields($tablename, $fieldname){
	global $_CB_database;

	$sql = "SHOW COLUMNS FROM $tablename LIKE '$fieldname'";
	$_CB_database->setQuery($sql);

	if(!$result=$_CB_database->query()) {
		echo '<p>'.$_CB_database->stderr().'</p>'; // this is not w3c valid
		return;
	}

	$fields = $_CB_database->loadObjectList();; 
	//print_r($fields); 
	return $fields;
}

function checkIfValueExists ($tablename, $fieldToCheck, $value, $enum = 0) {
	$fields = getTableFields($tablename, $fieldToCheck);
	if($enum == 1) {
		$types = explode("','",preg_replace("/(enum|set)\('(.+?)'\)/","\\2",$fields[0]->Type));
		foreach ($types as $type) {
			if ($type == $value) {
				return true;
				break;
			}
		}
	}
}

function checkIfFieldExists($tablename, $fieldToCheck, $enum = 0) {
	$fields = getTableFields($tablename, $fieldToCheck);
	foreach ($fields as $field) {
		if ($field->Field == $fieldToCheck) {
			return true;
			break;
		}	
	} 
	return false;
}

function handleImages() {
	global $_CB_framework;
	$mosConfig_absolute_path = $_CB_framework->getCfg('absolute_path');
	// template used from cb install file - regards to the cb team 
	showAction('check if imagepath is writable');
	if(is_writable($mosConfig_absolute_path . "/images/")) {
		showResult('imagepath is writable', true);
		$galleryFiles = array("groupjive_mini.png","index.html");

		showAction('check if folder /images/com_groupjive exists');
		if(!file_exists($mosConfig_absolute_path . "/images/com_groupjive/")){
			showResult('/images/com_groupjive does not exist', true);
			showAction('try to create /images/com_groupjive');
			if(mkdir($mosConfig_absolute_path . "/images/com_groupjive/")) {
				showResult($mosConfig_absolute_path . "/images/com_groupjive/ "
					. "Successfully added!", true);
			} else {
				showResult($mosConfig_absolute_path . "/images/com_groupjive/ "
					. "Failed to be to be created, please do so manually!", false);
			}
		} else {
			showResult($mosConfig_absolute_path . "/images/com_groupjive/ "
				. "already exists!", true);
		}
		
		showAction('check if folder /images/com_groupjive is writable');
		if(!is_writable($mosConfig_absolute_path . "/images/com_groupjive/")){
			showResult('folder /images/com_groupjive is not writable', true);
			showAction('try to chmod folder /images/com_groupjive to 777');
			if(!chmod($mosConfig_absolute_path . "/images/com_groupjive/", 0777)) {
				showResult($mosConfig_absolute_path . "/images/com_groupjive/ "
					. "Failed to be chmod'd to 777 please do so manually!", false);
			} else {
				showResult('folder /images/com_groupjive successfully chmodded to 777', true);
			}
		} else {
			showResult('folder /images/com_groupjive is writable', true);
		}

		foreach($galleryFiles AS $galleryFile) {
			showAction('try to copy file '.$galleryFile);
			if(copy($mosConfig_absolute_path . "/components/com_groupjive/images/"
				. $galleryFile,$mosConfig_absolute_path 
				. "/images/com_groupjive/".$galleryFile)) {
				showResult($galleryFile." successfully added to the image folder!", true);
			} else {
				showResult($galleryFile." failed to be added to the image folder please do so manually!", false);
			}
		}
	} else {
		showResult($mosConfig_absolute_path . "/images/ is not writable!<br />"
			. "Manually do the following:<br /> 1.) create "
			. $mosConfig_absolute_path . "/images/com_groupjive/ directory <br />"
			. "2.) chmod it to 777 <br /> "
			. "3.) copy ".$mosConfig_absolute_path . "/components/com_groupjive/images/ "
			. "and its contents to ".$mosConfig_absolute_path . "/images/com_groupjive/", false);
	}
	echo '</tr></table>';
}

function showAction($string){
	echo "<tr><td>$string</td>";
}
function showResult($string, $state){
	if ($state == false) {
		$font = 'red';
	} else {
		$font = 'green';	
	}
	echo "<td><font color=\"$font\">$string</td></tr>";
}

function indexExists($index, $table) {
	global $_CB_database, $_CB_framework;
	// DOESNT WORK YET
	// get indexes
	$sql = "SELECT COUNT( * ) FROM INFORMATION_SCHEMA.`KEY_COLUMN_USAGE` "
		. "WHERE TABLE_SCHEMA = '".$_CB_framework->getCfg( 'db')."' AND CONSTRAINT_NAME = '$index' AND TABLE_NAME LIKE '%$table'";
	//echo $sql;
	$_CB_database->setQuery($sql);
	$table_keys = $_CB_database->loadResult();

	if ($table_keys == 0) {
		$result = false;
	} else {
		$result = true;
	}
	// return result
	return $result;
}

function checkField($tablename, $fieldname, $fieldtype) {
	global $_CB_database;
	showAction('check if field `'.$fieldname.'` exists');
	if (!checkIfFieldExists($tablename, $fieldname)){
		showResult('field `'.$fieldname.'` does not exist', true);
		showAction('try to create field `'.$fieldname.'`');
		$sql = "ALTER TABLE `$tablename` ADD `$fieldname` $fieldtype ";
		$_CB_database->setQuery($sql);

		if(!$result=$_CB_database->query()) {
			showResult ('Error while alter table '.$tablename, false);
			echo '<tr><td colspan="2">'.$_CB_database->stderr().'</td></tr></table>';
			return;
		}
		showResult ('added field `'.$fieldname.'` to table '.$tablename, true);
	} else {
		showResult('field `'.$fieldname.'` already exist', true);
	}
}

/**
 * Function _gjAdmin_chmod
 * @package groupjive
 * @description chmods a file
 */
function _gjAdmin_chmod( $filename ) {
	global $_CB_framework;

	cbimport( 'cb.adminfilesystem' );
	$adminFS			=&	cbAdminFileSystem::getInstance();

	$origmask			=	null;
	if ( $_CB_framework->getCfg( 'dirperms' ) == '' ) {
		// rely on umask
		// $mode			=	0777;
		return true;
	} else {
		$origmask		=	@umask( 0 );
		$mode			=	octdec( $_CB_framework->getCfg( 'dirperms' ) );
	}
	$ret				=	$adminFS->chmod( $filename, $mode );

	if ( isset( $origmask ) ) {
		@umask( $origmask );
	}
	return $ret;
}

function showLicense() {
?>
<h3>License</h3>
<pre style="text-align:center;">This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
Link to the license: <a href="http://www.gnu.org/copyleft/gpl.html">http://www.gnu.org/copyleft/gpl.html</a></pre>
<?php
}
?>
